---
title: Monitors search
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Monitors
---

# Monitors search{% #monitors-search %}
Copy pageCopied
{% tab title="v1" %}

| Datadog site      | API endpoint                                            |
| ----------------- | ------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v1/monitor/search |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v1/monitor/search |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v1/monitor/search      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v1/monitor/search      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v1/monitor/search  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v1/monitor/search     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v1/monitor/search |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v1/monitor/search |

### Overview

Search and filter your monitors details. This endpoint requires the `monitors_read` permission.

OAuth apps require the `monitors_read` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#monitors) to access this endpoint.



### Arguments

#### Query Strings

| Name     | Type    | Description                            |
| -------- | ------- | -------------------------------------- |
| query    | string  |                                        |
| page     | integer | Page to start paginating from.         |
| per_page | integer | Number of monitors to return per page. |
| sort     | string  |                                        |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
The response from a monitor search.

| Parent field  | Field             | Type     | Description                                                                                                                                                                                                                                                                                                                |
| ------------- | ----------------- | -------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|               | counts            | object   | The counts of monitors per different criteria.                                                                                                                                                                                                                                                                             |
| counts        | muted             | [object] | Search facets.                                                                                                                                                                                                                                                                                                             |
| muted         | count             | int64    | The number of found monitors with the listed value.                                                                                                                                                                                                                                                                        |
| muted         | name              |          | The facet value.                                                                                                                                                                                                                                                                                                           |
| counts        | status            | [object] | Search facets.                                                                                                                                                                                                                                                                                                             |
| status        | count             | int64    | The number of found monitors with the listed value.                                                                                                                                                                                                                                                                        |
| status        | name              |          | The facet value.                                                                                                                                                                                                                                                                                                           |
| counts        | tag               | [object] | Search facets.                                                                                                                                                                                                                                                                                                             |
| tag           | count             | int64    | The number of found monitors with the listed value.                                                                                                                                                                                                                                                                        |
| tag           | name              |          | The facet value.                                                                                                                                                                                                                                                                                                           |
| counts        | type              | [object] | Search facets.                                                                                                                                                                                                                                                                                                             |
| type          | count             | int64    | The number of found monitors with the listed value.                                                                                                                                                                                                                                                                        |
| type          | name              |          | The facet value.                                                                                                                                                                                                                                                                                                           |
|               | metadata          | object   | Metadata about the response.                                                                                                                                                                                                                                                                                               |
| metadata      | page              | int64    | The page to start paginating from.                                                                                                                                                                                                                                                                                         |
| metadata      | page_count        | int64    | The number of pages.                                                                                                                                                                                                                                                                                                       |
| metadata      | per_page          | int64    | The number of monitors to return per page.                                                                                                                                                                                                                                                                                 |
| metadata      | total_count       | int64    | The total number of monitors.                                                                                                                                                                                                                                                                                              |
|               | monitors          | [object] | The list of found monitors.                                                                                                                                                                                                                                                                                                |
| monitors      | classification    | string   | Classification of the monitor.                                                                                                                                                                                                                                                                                             |
| monitors      | creator           | object   | Object describing the creator of the shared element.                                                                                                                                                                                                                                                                       |
| creator       | email             | string   | Email of the creator.                                                                                                                                                                                                                                                                                                      |
| creator       | handle            | string   | Handle of the creator.                                                                                                                                                                                                                                                                                                     |
| creator       | name              | string   | Name of the creator.                                                                                                                                                                                                                                                                                                       |
| monitors      | id                | int64    | ID of the monitor.                                                                                                                                                                                                                                                                                                         |
| monitors      | last_triggered_ts | int64    | Latest timestamp the monitor triggered.                                                                                                                                                                                                                                                                                    |
| monitors      | metrics           | [string] | Metrics used by the monitor.                                                                                                                                                                                                                                                                                               |
| monitors      | name              | string   | The monitor name.                                                                                                                                                                                                                                                                                                          |
| monitors      | notifications     | [object] | The notification triggered by the monitor.                                                                                                                                                                                                                                                                                 |
| notifications | handle            | string   | The email address that received the notification.                                                                                                                                                                                                                                                                          |
| notifications | name              | string   | The username receiving the notification                                                                                                                                                                                                                                                                                    |
| monitors      | org_id            | int64    | The ID of the organization.                                                                                                                                                                                                                                                                                                |
| monitors      | quality_issues    | [string] | Quality issues detected with the monitor.                                                                                                                                                                                                                                                                                  |
| monitors      | query             | string   | The monitor query.                                                                                                                                                                                                                                                                                                         |
| monitors      | scopes            | [string] | The scope(s) to which the downtime applies, for example `host:app2`. Provide multiple scopes as a comma-separated list, for example `env:dev,env:prod`. The resulting downtime applies to sources that matches ALL provided scopes (that is `env:dev AND env:prod`), NOT any of them.                                      |
| monitors      | status            | enum     | The different states your monitor can be in. Allowed enum values: `Alert,Ignored,No Data,OK,Skipped,Unknown,Warn`                                                                                                                                                                                                          |
| monitors      | tags              | [string] | Tags associated with the monitor.                                                                                                                                                                                                                                                                                          |
| monitors      | type              | enum     | The type of the monitor. For more information about `type`, see the [monitor options](https://docs.datadoghq.com/monitors/guide/monitor_api_options.md) docs. Allowed enum values: `composite,event alert,log alert,metric alert,process alert,query alert,rum alert,service check,synthetics alert,trace-analytics alert` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "counts": {
    "muted": [
      {
        "count": 3,
        "name": false
      },
      {
        "count": 3,
        "name": true
      }
    ],
    "status": [
      {
        "count": 4,
        "name": "No Data"
      },
      {
        "count": 2,
        "name": "OK"
      }
    ],
    "tag": [
      {
        "count": 6,
        "name": "service:cassandra"
      }
    ],
    "type": [
      {
        "count": 6,
        "name": "metric"
      }
    ]
  },
  "metadata": {
    "page": 0,
    "page_count": 6,
    "per_page": 30,
    "total_count": 6
  },
  "monitors": [
    {
      "classification": "metric",
      "creator": {
        "handle": "john@datadoghq.com",
        "name": "John Doe"
      },
      "id": 2699850,
      "last_triggered_ts": null,
      "metrics": [
        "system.cpu.user"
      ],
      "name": "Cassandra CPU is high on {{host.name}} in {{availability-zone.name}}",
      "notifications": [
        {
          "handle": "jane@datadoghq.com",
          "name": "Jane Doe"
        }
      ],
      "org_id": 1234,
      "quality_issues": [
        "broken_at_handle",
        "noisy_monitor"
      ],
      "scopes": [
        "!availability-zone:us-east-1c",
        "name:cassandra"
      ],
      "status": "No Data",
      "tags": [
        "service:cassandra"
      ],
      "type": "query alert"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
Error response object.

| Field                    | Type     | Description                          |
| ------------------------ | -------- | ------------------------------------ |
| errors [*required*] | [string] | Array of errors returned by the API. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
Error response object.

| Field                    | Type     | Description                          |
| ------------------------ | -------- | ------------------------------------ |
| errors [*required*] | [string] | Array of errors returned by the API. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
Error response object.

| Field                    | Type     | Description                          |
| ------------------------ | -------- | ------------------------------------ |
| errors [*required*] | [string] | Array of errors returned by the API. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Curl command curl -X GET "https://api.datadoghq.com/api/v1/monitor/search" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
Monitors search returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v1.api.monitors_api import MonitorsApi

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = MonitorsApi(api_client)
    response = api_instance.search_monitors()

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Monitors search returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V1::MonitorsAPI.new
p api_instance.search_monitors()
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```ruby
require 'dogapi'

api_key = '<DATADOG_API_KEY>'
app_key = '<DATADOG_APPLICATION_KEY>'

dog = Dogapi::Client.new(api_key, app_key)

# Search monitors
dog.search_monitors

# Examples of possible query parameters:
# dog.search_monitors(query="id:7100311")
# dog.search_monitors(query="title:foo metric:system.core.idle status:Alert")
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby-legacy) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Monitors search returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV1"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV1.NewMonitorsApi(apiClient)
	resp, r, err := api.SearchMonitors(ctx, *datadogV1.NewSearchMonitorsOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `MonitorsApi.SearchMonitors`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `MonitorsApi.SearchMonitors`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Monitors search returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v1.api.MonitorsApi;
import com.datadog.api.client.v1.model.MonitorSearchResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    MonitorsApi apiInstance = new MonitorsApi(defaultClient);

    try {
      MonitorSearchResponse result = apiInstance.searchMonitors();
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling MonitorsApi#searchMonitors");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
from datadog import initialize, api

options = {
	'api_key': '<DATADOG_API_KEY>',
	'app_key': '<DATADOG_APPLICATION_KEY>'
}

initialize(**options)

# Search monitors
api.Monitor.search()

# Examples of possible query parameters:
# api.Monitor.search(query="id:7100311")
# api.Monitor.search(query="title:foo metric:system.core.idle status:Alert")
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python-legacy) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python "example.py"
##### 

```rust
// Monitors search returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV1::api_monitors::MonitorsAPI;
use datadog_api_client::datadogV1::api_monitors::SearchMonitorsOptionalParams;

#[tokio::main]
async fn main() {
    let configuration = datadog::Configuration::new();
    let api = MonitorsAPI::with_config(configuration);
    let resp = api
        .search_monitors(SearchMonitorsOptionalParams::default())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Monitors search returns "OK" response
 */

import { client, v1 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v1.MonitorsApi(configuration);

apiInstance
  .searchMonitors()
  .then((data: v1.MonitorSearchResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
